local tools = require "tools"

--删除多个好友
--friendNames	需删除的好友名称
--callback	删除完成后的回调,回调接受一个table，用于保存删除失败的好友
local function deleteFriends(friendNames, callback)
	local ID_FOUND_FRIEND = "kpm" --搜索到的好友

	local currentIndex = 0 --索引正在删除的好友
	local failedFriends = {} --删除失败的好友

	--粘贴下一个好友的名称
	pasteNext = function()
		currentIndex = currentIndex + 1
		local friendName = friendNames[currentIndex]
		service.setText(friendName)
		return true
	end

	--点击当前的好友名称
	clickName = function()
		local friendName = friendNames[currentIndex]
		local nodeInfo = service.findAccessibilityNodeInfo(friendName)
		return service.click(nodeInfo)
	end

	--将当前好友添加到失败列表
	addFailedFriend = function()
		local friendName = friendNames[currentIndex]
		table.insert(failedFriends, friendName)
		return true
	end

	local actionList = {}
	local initList = {
		{ {
			">微信",
			"微信#1&通讯录>20$500",
		} }
	}

	local loopList = {
		{ {
			"搜索",
			"<取消按钮>25$200",
			"%pasteNext$200",
			"#" .. ID_FOUND_FRIEND .. "#1>25$200",
			--"最常使用|联系人>25$200",
			--"%下个焦点$200",
			--"%点击$200",
			"%清空$200",
			"更多信息&更多功能按钮，已折叠>25$200",
			"<消息免打扰>25$200",
			"%clickName$200",
			"更多信息>25$200",
			"<删除>25$200",
			"%模拟点击$1",
			"删除&删除联系人>25$200",
			"<搜索>50$200",
		} },
		{ {
			"%返回&!搜索$200",
			"%朗读/执行中断，正在返回",
			"%addFailedFriend$1",
			"%返回&!搜索<5",
		} },
	}

	tools.append(actionList, initList)
	local tmp = {}
	for n = 1, #friendNames do
		tools.append(tmp, loopList)
	end
	table.insert(actionList, { tmp })

	service.click({
		{
			--"%朗读/开始删除",
			{ actionList },
			--"%朗读/删除完成",
		}
	}, function()
		callback(currentIndex, failedFriends)
	end)
end

return deleteFriends
