local deleteFriends = require "deleteFriends"
local friendsManager = require "friendsManager"
local MultiSelector = require "MultiSelector"
local tools = require "tools"

-- 删除完成后的回调
local function onDeleteComplete(deletedNum, deleteFailedFriends)
    local msg = "删除完成！"
    if #deleteFailedFriends > 0 then
        msg = msg .. "\n" .. #deleteFailedFriends .. "位好友删除失败：\n" ..
            table.concat(deleteFailedFriends, "\n")
    end
    LuaDialog().setMessage(msg).setButton("确定", function()
        mainMenu()
    end).show()
end

local function deleteFriends_dialog()
    local friends = {}
    tools.append(friends, friendsManager.read("deletedFriends"))
    tools.append(friends, friendsManager.read("badFriends"))
    tools.append(friends, friendsManager.read("blacklistFriends"))

    if #friends == 0 then
        LuaDialog().setMessage("没有需删除的好友").setButton("确定", mainMenu).show()
        return false
    end

    local mSelector = MultiSelector()
    mSelector.setTitle("请选择要删除的好友")
    mSelector.setItems(friends)
    mSelector.setOnClickCancel(mainMenu)
    mSelector.setOnClickOk(function(checkedItems)
        local selectedFriends = {}
        for i, v in ipairs(checkedItems) do
            table.insert(selectedFriends, friends[v])
        end
        deleteFriends(selectedFriends, onDeleteComplete)
    end)

    mSelector.show()
end

return deleteFriends_dialog
