local tools = require "tools"

local function detectFriends(friendNames, callback)
	local ID_FOUND_FRIEND = "kpm" --搜索到的好友
	local ID_BACK = "g0" --左上角的返回按钮

	local currentIndex = 0 --索引正在检测的好友
	local deletedFriends = {}
	local badFriends = {}
	local blacklistFriends = {}
	local failedFriends = {}

	function pasteNext()
		currentIndex = currentIndex + 1
		local friendName = friendNames[currentIndex]
		service.setText(friendName)
		return true
	end

	function addDeletedFriend()
		local friendName = friendNames[currentIndex]
		table.insert(deletedFriends, friendName)
		return true
	end

	function addBadFriend()
		local friendName = friendNames[currentIndex]
		table.insert(badFriends, friendName)
		return true
	end

	function addBlacklistFriend()
		local friendName = friendNames[currentIndex]
		table.insert(blacklistFriends, friendName)
		return true
	end

	function addFailedFriend()
		local friendName = friendNames[currentIndex]
		table.insert(failedFriends, friendName)
		return true
	end

	function detectComplete()
		local detectedNum = currentIndex
		local friends = {
			deletedFriends = deletedFriends,
			badFriends = badFriends,
			blacklistFriends = blacklistFriends,
			failedFriends = failedFriends,
		}
		callback(detectedNum, friends)
		return true
	end

	local ID_CLEAR = "k17" --清空按钮的ID
	local actionList = {}
	local initList = {
		{ {
			">微信",
			"微信#1&通讯录>20$500",
			"搜索>25$200",
			"%输入/开始",
		} }
	}

	local loopList = {
		{ {
			-- "<取消按钮$200",
			-- "清除&取消按钮>25$200",
			-- "%清空&取消按钮$200",
			"#"..ID_CLEAR.."&取消按钮$200",
			"%pasteNext$200",
			"#" .. ID_FOUND_FRIEND .. "#1>25$200",
			--"最常使用|联系人>25$200",
			--"%下个焦点$200",
			--"%点击$200",
			"更多功能按钮，已折叠>25$200",
			--{{"%返回&!转账","%返回&更多功能按钮，已折叠>25$200","%朗读/该项不是个人好友，无需检测，正在准备跳过，请稍后"}},
			"<转账>25$200",
			"%模拟点击$1",
			"1&转账金额>25$200",
			"转账>25$200",
			"<我知道了|向*>20$500",
			{
				{ "向*$200", "关闭*>25$200" },
				{ "<你不是收款方好友*$200", "我知道了>25$200", "%addDeletedFriend$200" },
				{ "<对方微信号已被限制登录*$200", "我知道了>25$200", "%addBadFriend$200", },
				{ "<请确认你和他*$200", "我知道了>25$200", "%addBlacklistFriend$200", },
			},
			"#" .. ID_BACK .. "#1&删除>25$200",
			--"%返回&删除>25$200",
			--"%返回&!删除>25$200",
			"#" .. ID_BACK .. "#1&视频通话>25$200",
			--"%返回&视频通话>25$200",
			--"%返回&!视频通话>25$200",
		} },
		{ {
			"%返回&!取消按钮$200",
			"%朗读/检测中断，正在返回",
			"%addFailedFriend$1",
			"%返回&!取消按钮<3",
		} },
	}

	tools.append(actionList, initList)
	local tmp = {}
	for n = 1, #friendNames do
		tools.append(tmp, loopList)
	end
	table.insert(actionList, { tmp })

	local loopClick = service.loopClick(1, 1, {
		{
			{ actionList },
			{ "取消按钮" },
			"%朗读/检测完成",
			"%detectComplete",
		}
	})
	service.speak("检测开始")

	return {
		stop = function()
			loopClick.cancel()
			detectComplete()
		end
	}
end

return detectFriends
