local tools = require "tools"

local ID_PREFIX = "com.tencent.mm:id/" -- 微信viewID 的前缀
--local ID_FRIEND_LIST = "l_m" -- 好友列表的ID
local ID_FRIEND_NAME = "hg4" -- 好友名称的ID

local function getAllFriends()
	local friendNames = {}
	local rootNodeInfo = service.getRootNodeInfo()
	--local friendList = rootNodeInfo.findAccessibilityNodeInfosByViewId(ID_PREFIX .. ID_FRIEND_LIST)[0]
	local friendList = service.findListView(rootNodeInfo)
	local items = {} -- 保存列表项目

	-- 不断向下滚动列表，查找节点
	while true do
		items = friendList.findAccessibilityNodeInfosByViewId(ID_PREFIX .. ID_FRIEND_NAME)
		for i = 0, #items - 1 do
			local item = items[i]
			table.insert(friendNames, item.text)
		end

		if not service.scrollForward(friendList) then
			break
		end
		os.execute("sleep 0.1")
	end -- while循环结束
	-- 去除重复的名称
	friendNames = tools.arrayToSet(friendNames)
	return friendNames
end

local function getFriendList(callback)
	service.click({ {
		">微信",
		"更多功能按钮>20$500",
		"发起群聊>25$200",
		"<完成>25$200",
		"%朗读/正在扫描，请稍后……$3000",
	} }, function(isOk)
		if not isOk then
			callback()
			return
		end
		local allFriends = getAllFriends()
		service.click({ "%返回" })
		callback(allFriends)
	end)
end

return getFriendList
