local getFriendList = require "getFriendList"
local selectFriends = require "selectFriends"
local friendsManager = require "friendsManager"
local tools = require "tools"

local function getFriendList_dialog()
    local dlg = LuaDialog()
    dlg.setTitle("获取好友列表")
    dlg.setMessage(
        "点击开始后将跳转到“发起群聊”界面，自动读取全部好友的名称。若您的通讯录中存在同名好友，建议先去修改对方的备注名。")
    dlg.setCancelable(false)
    dlg.setNegativeButton("取消", mainMenu)
    dlg.setPositiveButton("开始", function()
        getFriendList(function(allFriends)
            if nil == allFriends or 0 == #allFriends then
                print("获取好友列表失败！")
                return
            end
            friendsManager.set("allFriends", allFriends)
            friendsManager.write("allFriends")
            selectFriends()
            tools.showToast("获取完成！共有" .. #allFriends .. "位好友")
        end)
    end)
    dlg.show()
    return true
end

return getFriendList_dialog
