local getFriendList_dialog = require "getFriendList_dialog"
local selectFriends = require "selectFriends"
local detectFriends_dialog = require "detectFriends_dialog"
local showDetectResult = require "showDetectResult"
local deleteFriends_dialog = require "deleteFriends_dialog"
local showHelp = require "showHelp"
local reward = require "reward/reward"

local function minMenu()
	local taskNames = {
		"获取好友列表",
		"选择好友",
		"开始检测",
		"查看检测结果",
		"删除异常好友",
		"查看插件说明",
		"打赏支持",
	}

	local taskList = {
		getFriendList_dialog,
		selectFriends,
		detectFriends_dialog,
		showDetectResult,
		deleteFriends_dialog,
		showHelp,
		reward,
	}

	local dlg = LuaDialog(service)
		.setTitle(PLUGIN_NAME .. " v" .. PLUGIN_VERSION)
		.setItems(taskNames)
		.setCancelable(false)
		.setButton("退出", function() end)
		.show()

	dlg.onItemClick = function(l, v, p, i)
		local task = taskList[i]
		if type(task) == "function" then
			dlg.dismiss()
			task(mainMenu)
		end
	end
	return dlg
end

return minMenu
