local tools = require "tools"
local MultiSelector = require "MultiSelector"
local detectFriends_dialog = require "detectFriends_dialog"
local friendsManager = require "friendsManager"

local function selectFriends()
    local allFriends = friendsManager.read("allFriends")
    local selectedFriends = friendsManager.read("selectedFriends")

    -- 获取上次的选择
    local defaultChecked = {}
    for i, v in ipairs(selectedFriends) do
        local index = tools.indexOf(allFriends, v)
        if index ~= -1 then
            table.insert(defaultChecked, index)
        end
    end

    -- 调用选择器
    local mSelector = MultiSelector()
    mSelector.setTitle("请选择需检测的好友")
    mSelector.setItems(allFriends, defaultChecked)
    mSelector.setOnClickCancel(mainMenu)
    mSelector.setOnClickOk(function(checkItems)
        local selectedFriends = {}
        for i, v in ipairs(checkItems) do
            table.insert(selectedFriends, allFriends[v])
        end
        friendsManager.set("selectedFriends", selectedFriends)
        friendsManager.write("selectedFriends")
        detectFriends_dialog()
    end)
    mSelector.show()
end

return selectFriends
