-- 计时器
local timer = {
    startTimes = {} -- 记录开始时间
}

-- 开始计时
timer.startTiming = function(key)
    if key == nil then
        key = "default"
    end
    if timer.startTimes[key] ~= nil then
        error("\"" .. key .. "\"已存在")
    end
    timer.startTimes[key] = os.time()
end

-- 结束计时
timer.endTiming = function(key)
    if key == nil then
        key = "default"
    end
    local endTime = os.time()
    local startTime = timer.startTimes[key]
    if nil == startTime then
        error('"' .. key .. '"不存在')
    end
    timer.startTimes[key] = nil
    return os.difftime(endTime, startTime)
end

return timer
